#!/usr/bin/python
# -*- coding:utf-8 -*-

from dom import *
import scorecard
import makelogo

def newInstance():
    return NPBYahoo2005()

class NPBYahoo2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        self.date = None
        self.games = []
        return
        
    def getName( self ):
        return "プロ野球 (Yahoo)"

    def getVersion( self ):
        return "1.0"

    def getSportsCategory( self ):
        return "野球"

    def getCountry( self ):
        return "Japan"

    def getURL( self ):
        return "http://baseball.yahoo.co.jp/npb/" #"http://www.nikkansports.com/ns/soccer/jleague/score/j1_nscore.html"

    def decode( self, contents ):
        import re
        if contents == self.getStartKeyword(): return contents
        contents = re.sub( "<option[^>]*>", "", contents )
        contents = re.sub( "<!--.{0,10}-->", "", contents )
        contents = re.sub( "alt=[^\"]([^\\\"\\s>]+)", "", contents )
        return unicode( contents, self.getEncoding() ).encode( 'utf-8' )

    def getEncoding( self ):
        return 'euc-jp'

    def getStartKeyword( self ):
        return "<!---main--->"
        return None
        #return None
        #return "<!---/SCHEDULE NAVI--->"

    def getEndKeyword( self ):
        #return None
        #return None
        return "<hr size=1>"#"免責事項"#"<!-- Start of Footer -->"

    def getIcon( self, team ):
        if team == "中日":          name = "d"
        elif team == "ヤクルト":     name = "s"
        elif team == "巨人":        name = "g"
        elif team == "阪神":        name = "t"
        elif team == "広島":        name = "c"
        elif team == "横浜":        name = "yb"
        elif team == "西武":        name = "l"
        elif team == "ソフトバンク": name = "h"
        elif team == "日本ハム":     name = "f"
        elif team == "ロッテ":      name = "m"
        elif team == "オリックス":   name = "bs"
        elif team == "楽天":        name = "e"
        try:
            uri = makelogo.getURI( 'http://www.npb.or.jp/images/npb/pet40inter_%s.gif' % name, 'npb', name, transparency=None )
            return '<td class="teamlogo"><img src="%s" class="logo"/></td>' % uri
        except Exception, e:
            raise
            return ''
        pass


    def interpreteDocument( self, document ):
        import re, sys
        #print document
        self.games = []
        elem_game = document.get_element_at_path( "/html/table/tr/td/table/tr/td/table/tr" )
        while elem_game != None:
            items = elem_game.get_text( '*,*' ).split( '*,*' )
            if len( items ) > 5:
                scores = items[ 1 ].split( '-' )
                if len( scores ) > 1:
                    status = ""
                    for item in items[ 4: ]:
                        status += " " + item
                        pass
                    self.games.append( ( items[ 0 ], items[ 2 ], scores[ 0 ], scores[ 1 ], items[ 3 ], status ) )
                    pass
                pass
            try:
                elem_game = elem_game.next_sibling()
            except:
                break
            pass
        return

    def getDate( self ):
        if not self.date:
            return ""
        return self.date

    def toHTML( self ):
        html = self.html_header()
        html += '<title>%s</title>' % ( self.getName() )
        html += "<body>"
        if len( self.games ) > 0:
            html += '<span class="tabletitle">%s %s</span>' % ( self.getName(), self.getDate() )
            html += "<table>"
            for game in self.games:
                team1 = self.getIcon( game[ 0 ] ) \
                        + '<td class="team">%s</td>' % game[ 0 ]
                team2 = '<td class="team">%s</td>' % game[ 1 ] \
                        + self.getIcon( game[ 1 ] )
                html += '<tr>%s<td class="score">%s - %s</td>%s<td class="place">%s</td><td class="status">%s</td></tr>\n' % ( team1, game[ 2 ], game[ 3 ], team2, game[ 4 ], game[ 5 ] )
                pass
            html += "</table>"
        else:
            html += "<div id=\"error\">データの取得に失敗しました</div>"
            pass
        html += "</body>"
        html += self.html_footer()
        return html        

    pass

if __name__ == "__main__":
    from loader import *
    obj = newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        data = loadHTML_test( "../../html/npb_yahoo_jp.html" )
        #data = unicode( loadHTML_test( "../../html/npb_yahoo_jp.html" ), obj.getEncoding() ).encode( 'utf-8' )
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            for line in data.split( "\n" ):
                parser.feed( obj.decode( line ) )
                pass
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                if flag_inside:
                    if line.count( kw_end ): flag_inside = False
                    else: parser.feed( line )
                elif line.count( kw_start ):
                    flag_inside = True
                    pass
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        #file_out = open( filename_output, "w" )
        #file_out.write( obj.toHTML() )
        #file_out.close()
        #uri = "file://%s" % filename_output
        #print uri
        pass
    pass


#data = unicode( open( "../html/j1.html" ).readlines().join( "" ), 'sjis' )
    
